datablock AudioProfile(M6SFireSound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6SclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6SclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6SclipIn_eSound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6SclipOut_eSound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(M6SCasing)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

AddDamageType("M6S",   '<bitmap:add-ons/Weapon_M6S/CI_M6S> %1',    '%2 <bitmap:add-ons/Weapon_M6S/CI_M6S> %1',0.2,1);
datablock ProjectileData(M6SProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 25;
   directDamageType    = $DamageType::M6S;
   radiusDamageType    = $DamageType::M6S;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "M6S Bullet";
};

//////////
// item //
//////////
datablock ItemData(M6SItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M6S_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M6C SOCOM";
	iconName = "./UI_M6S";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = M6SImage;
	canDrop = true;

	maxAmmo = 12;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M6SImage)
{
   // Basic Item properties
   shapeFile = "./M6S.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M6SItem;
   ammo = " ";
   projectile = M6SProjectile;
   projectileType = Projectile;

	casing = M6SCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M6SItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.63;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	//stateSound[0]				= M6SUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.10;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	//stateEmitter[2]				= M6SFlashEmitter;
	//stateEmitterTime[2]			= 0.05;
	//stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= M6SFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.1;
	//stateEmitter[7]				= gunSmokeEmitter;
	//stateEmitterTime[7]			= 0.01;
	//stateEmitterNode[7]			= "muzzleNode";
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload2";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.5;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= M6SclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.75;
	stateSound[11]				= M6SclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	//stateEmitter[14]			= gunSmokeEmitter;
	//stateEmitterTime[14]			= 0.3;
	//stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.1;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	//stateEmitter[15]			= gunSmokeEmitter;
	//stateEmitterTime[15]			= 0.3;
	//stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "Reload2";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
	
		//empty reload states
	stateName[17]				= "Reload2";
	stateTimeoutValue[17]			= 0.56;
	stateScript[17]				= "onReloadStart";
	stateTransitionOnTimeout[17]		= "Wait2";
	stateWaitForTimeout[17]			= true;
	stateSequence[17]			= "clipOut_e";
	stateSound[17]				= M6SclipOut_eSound;
	
	stateName[18]				= "Wait2";
	stateTimeoutValue[18]			= 0.51;
	stateSound[18]				= M6SclipIn_eSound;
	stateScript[18]				= "onReloadWait";
	stateSequence[18]			= "clipIn_e";
	stateTransitionOnTimeout[18]		= "Reloaded";
	
	stateName[19]				= "Reloaded2";
	stateTimeoutValue[19]			= 0.01;
	stateScript[19]				= "onReloaded";
	stateTransitionOnTimeout[19]		= "Ready";

	
};

function M6SImage::onFire(%this,%obj,%slot)
{
	%projectile = M6SProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00005;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}


function M6SImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M6SImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function M6SImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 12;
	%obj.setImageAmmo(%slot,1);
}

function M6SImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M6SImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}